function [direc]=directions(A,m,Tol)

%disp('Subrotine of the main file banded_2Toeplitz_definite_main routine.m');
%disp(' ')
%disp('Programmer: Ana Nata');
%disp('CMUC and Department of Mathematics') 
%disp('Polytechnic Institute of Tomar, Portugal')
%disp('e-mail: anata@ipt.pt')
%disp(' ');
%disp('April 2011')
%disp(' ')
%disp('In this subroutine, the directions theta_r=(r-1)/2m, for r=1,...,2m are');
%disp('computed and the multiplicity of the eigenvalues of the Hermitian matrix H');
%disp('is checked in each direction'); 

%%
i=sqrt(-1);
direc=[];
    row1=1;
        for r=1:(2*m)
            H=(exp(pi*i*(r-1)/(2*m))*A+exp(-pi*i*(r-1)/(2*m))*A')/2;
            lambda=eig(H);
                for s=1:size(lambda,1)
                    if abs(imag(lambda(s,1)))<=Tol 
                        direc(row1)=r;          
                        [mult]=multiplicity(H,Tol);
                        %If there exists some direction for which the eigenvalues
                        %have multiplicity greater than 1, THEN we slightly disturbed
                        %the direction
                            if mult==1
                                direc(row1)=r+10^(-10); %disturbed the direction
                            end    
                        row1=row1+1;
                        break;
                    end
                end
        end
        
    
        
        
 
        